#ifndef _h_CONFIG_
#define _h_CONFIG_

#include <stdio.h>
#ifndef _h_CPPHELP_
# include <cv/cpphelp.h>
#endif
#ifndef _h_STATES_
# include <cv/states.h>
#endif
#ifndef _h_STRING_
# include <cv/string.h>
#endif


class rconfig;
class wconfig;
class _config;


/*---------------------------------------------------------*/
class _config{
    NoCopy(_config)
    NoAssignment(_config)
public:
    bool	open(FILE *cfg)	{ close(); return _link(cfg); }
    bool	open(CStr name)	{ close(); return _open(name); }
    ~_config()			{ if(cfg) close(); }
    bool SMALL_	close();

    operator	bool() const	{ return bool(cfg != NULL); }
    bool SMALL_	check() const;

    static void SMALL_ parse(charSeq &sect);
    void SMALL_	parse(charSeq, charSeq &key, charSeq &val, charSeq &comment);

    void	setComment(char cmt, char note) { CMT = cmt; NOTE = note; }
protected:
    enum Mode { read, write } mode;
    FILE *cfg;
    char CMT, NOTE;
    _config(Mode mode) :mode(mode), CMT(';'), NOTE(0) {} /* initializer */
    bool SMALL_	_link(FILE*);				 /* constructors part */
    bool SMALL_	_open(CStr name);			 /* constructors part */
}; /* _config */


/*---------------------------------------------------------*/
class rconfig :public _config{
public:
    struct pos{
	fpos_t	psect, pcurr;
	count	sline, lineno;
    };
    struct state{
	pos	p;
	bool	allkey;
	string<> section, key;
    };

    rconfig()		:_config(read) { _link(NULL); }
    rconfig(FILE *cfg)	:_config(read) { _link(cfg); }
    rconfig(CStr name)	:_config(read) { _open(name); }

    void SMALL_	getpos(pos&);
    void SMALL_	setpos(const pos&);
    void SMALL_	getstate(state&);
    void SMALL_	setstate(const state&);

    bool SMALL_	openSection(charSeq);
    bool SMALL_	nextSection();
    bool SMALL_	get(charSeq key, String &val);
    bool SMALL_	next(String&);
    bool SMALL_	fullnext(String&);

    count	lineno() const		{ return line; }
    string<>	section, key;
protected:
    REDEF bool SMALL_ _link(FILE*);
private:
    fpos_t	psect;
    count	sline, line;
    bool	allkey;
}; /* rconfig */


/*---------------------------------------------------------*/
class wconfig :public _config, public States{
public:
	StatesInherit(States)
	StatesDeclare(0, stmtSpace)
	StatesEnd(1)

    wconfig()		:_config(write) { _link(NULL); }
    wconfig(FILE *cfg)	:_config(write) { _link(cfg); }
    wconfig(CStr name)	:_config(write) { _open(name); }

    void SMALL_	put(charSeq sect);
    void SMALL_	put(charSeq key, charSeq val, charSeq comment = nullSeq);
    void SMALL_	fullput(charSeq);
protected:
    REDEF bool SMALL_ _link(FILE*);
}; /* wconfig */


#endif /* _h_CONFIG_ */
