#include <io.h>
#include <stdlib.h>
#include <cv/convert.h>
#include "inc/trace.inc"


bool	STD_	_allowredirect = true,
	STD_	_alwaysconsole = true,
	STD_	_warn = true,
	STD_	_trace = false;

count	STD_	_msgwidth = 80;


/*----------------------------------------------------------------------*/
count FAST_ say(CVP buf, size_t sz){
	int tty = isatty(1);
	if(_allowredirect || tty)	write(1, buf, sz);
	if(_alwaysconsole && tty == 0)	write(2, buf, sz);
	return sz;
}

/* "Check for stack overflow" off for BC++ 3.1 */
#pragma option -N-

count FAST_ say(CStr s) { return say(s, checklen(s)); }

count FAST_ say(count val){
	char buf[bitsPer(val) / 3 + 2]; return say(buf, u2a(val, buf));
}

/*----------------------------------------------------------------------*/
static count outcnt, follow;

static void FAST_ _say(CVP buf, size_t sz){
	count w = _msgwidth; if(outcnt >= w) return;
	w -= outcnt;
	if(sz + 3 < w || sz < w && follow == 0){
		say(buf, sz); outcnt += sz;
	}else{
		if(w > 4) { say(buf, w - 4); w = 4; }
		say("...", w - 1); outcnt = _msgwidth;
}	}

static void FAST_ _say(CStr s) { _say(s, checklen(s)); }

/*----------------------------------------------------------------------*/
void SMALL_ trace_say_(CStr what, count line, CVP msg, size_t msglen,
			CVP arg1, size_t arg1len, CVP arg2, size_t arg2len){
	outcnt = 0; follow = 1; _say(what);
	if(line){
		_say("line "); outcnt += say(line); _say(": ");
	}
	follow = arg1len + arg2len; _say(msg, msglen);
	if(arg1len) { _say(" ("); follow = arg2len; _say(arg1, arg1len); _say(")"); }
	if(arg2len) { _say(" \""); follow = 0; _say(arg2, arg2len); _say("\""); }
	say("\n");
}
